/*
 * Inter.cpp:
 *
 * This file provides all the really platform-dependant interface stuff.
 *
 * Copyright (c) Malcolm Smith 2001-2005.  No warranty is provided.
 */

#include "pch.h"

int RefreshList(HWND hWnd,LIST * List,BOOL bFullPath)
{
	DWORD i;
	LPSTR a,b;
	SendMessage(hWnd,LB_RESETCONTENT,0,0);
	for (i=0;i<List->dwItemsInList;i++) {
		a=GetListItem(List,i);

		if (!bFullPath) {
			a=GetPtr(a,SORT_DISPLAY);
			if (b=strrchr(a,'.')) b[0]='\0';
		}
		SendMessage(hWnd,LB_ADDSTRING,0,(LPARAM)a);
		if (!bFullPath) if (b) b[0]='.';
	}
	return(0);
}


int GetaFile(LPSTR szFile,BOOL Save)
{
	char szTemp[256];
	char szTemp2[512];
	char szTitle[255];
	OPENFILENAME ofn;
	memset(&ofn,0,sizeof(ofn));
	ofn.lStructSize=sizeof(ofn);
	ofn.hwndOwner=GethWndMain();
	ofn.hInstance=GethInst();
	ofn.hInstance=NULL;
	ofn.lpstrCustomFilter=NULL;
	ofn.nMaxCustFilter=0;
	ofn.nFilterIndex=0;
	ofn.lpstrFile=szFile;
	ofn.nMaxFile=MAX_PATH-2;
	ofn.lpstrFileTitle=szTitle;
	ofn.nMaxFileTitle=sizeof(szTitle);
	ofn.lpstrInitialDir=NULL;
	ofn.lpfnHook=NULL;
	ofn.lpTemplateName=NULL;
	if (!Save) {
		LPSTR a;
		ofn.lpstrTitle="Open";
		EnumHandlerExtensions(szTemp,";");
		ofn.lpstrDefExt="m3u";
		sprintf(szTemp2,"Known files (*.m3u;*.msc%s)",szTemp);
		a=szTemp2+strlen(szTemp2)+1;
		sprintf(a,"*.m3u;*.msc%s",szTemp);
		a=a+strlen(a)+1;
		a[0]='\0';
		ofn.lpstrFilter=szTemp2;
	} else {
		ofn.lpstrTitle="Save As";
		ofn.lpstrDefExt="m3u";
		ofn.lpstrFilter="Playlist files (*.m3u)\0*.m3u\0\0";
	}
	ofn.nFileOffset=0;
	ofn.nFileExtension=0;
	ofn.lCustData=0;
	if (!Save) {
		return(GetOpenFileName(&ofn));
	} else {
		return(GetSaveFileName(&ofn));
	}
}

int GetSelFile(HWND hWnd)
{
	int i;
	i=(int)SendMessage(hWnd,LB_GETCURSEL,0,0);
	if (i==LB_ERR) {
		SendMessage(hWnd,LB_SETCURSEL,0,0);
		i=0;
	}
	return(i);
}


int SetActiveItem(DWORD dwNewItem)
{
	HWND hWnd;
	hWnd=GethWndCli();
	SendMessage(hWnd,LB_SETCURSEL,(WPARAM)dwNewItem,0);
	return(0);

}

int RefreshTitle(LPSTR szTitle)
{
	char szTemp[MAX_PATH];
	sprintf(szTemp,"%s - [%s]",product,szTitle);
	SetWindowText(GethWndMain(),szTemp);
	return(0);
}

#ifndef WIN3X_CONTROLS
int AddTrayIcon(HWND hWnd)
{
	NOTIFYICONDATA tnd;
	tnd.uFlags=NIF_MESSAGE|NIF_ICON|NIF_TIP;
	tnd.uID=TRAYICON;
	tnd.cbSize=sizeof(tnd);
	tnd.hWnd=hWnd;
	tnd.uCallbackMessage=TRAY_CALLBACK;
	tnd.hIcon=LoadIcon(GethInst(),"TRAYICON");
	strcpy(tnd.szTip,product);
	Shell_NotifyIcon(NIM_ADD,&tnd);
	return(TRUE);
}

int DelTrayIcon(HWND hWnd)
{
	NOTIFYICONDATA tnd;
	tnd.uFlags=NIF_MESSAGE|NIF_ICON;
	tnd.uID=TRAYICON;
	tnd.cbSize=sizeof(tnd);
	tnd.hWnd=hWnd;
	Shell_NotifyIcon(NIM_DELETE,&tnd);

	return(TRUE);
}

int CvttoTime(LPSTR szTemp,DWORD dwVal)
{
	if (dwVal>(1000*60*60)) {
		sprintf(szTemp,"%.2i:%.2i:%.2i",dwVal/3600000,dwVal%3600000/60000,dwVal%60000/1000);
	} else {
		sprintf(szTemp,"%.2i:%.2i",dwVal%3600000/60000,dwVal%60000/1000);
	}
	return(TRUE);
}

int SetTrackerLength(DWORD dwValue)
{
	HWND hWnd;
	DWORD tf=1;
	char szTime[32];
	if (dwValue>30000) tf=5;
	if (dwValue>60000) tf=15;
	if (dwValue>240000) tf=30;
	if (dwValue>600000) tf=60;
	hWnd=GethWndPtr();
	SendMessage(hWnd,TBM_SETRANGE,TRUE,MAKELPARAM(0,dwValue/1000));
	SendMessage(hWnd,TBM_SETTICFREQ,tf,0);
	CvttoTime(szTime,dwValue);
	SendMessage(GethWndStatus(),SB_SETTEXT,1,(LPARAM)szTime);

	return(0);
}

int SetTrackerPos(DWORD dwValue)
{
	char szTime[32];
	HWND hWnd;
	hWnd=GethWndPtr();
	SendMessage(hWnd,TBM_SETPOS,TRUE,dwValue/1000);
	CvttoTime(szTime,dwValue);
	SendMessage(GethWndStatus(),SB_SETTEXT,0,(LPARAM)szTime);
	return(0);
}

int GetTrackerPos()
{
	HWND hWnd;
	hWnd=GethWndPtr();
	return (int)SendMessage(hWnd,TBM_GETPOS,0,0)*1000;
}

BOOL SetOpenFile(LPSTR szFile)
{
	return (BOOL)SendMessage(GethWndStatus(),SB_SETTEXT,2,(LPARAM)szFile);
} 
#else
int AddTrayIcon(HWND hWnd){return(FALSE);}
int DelTrayIcon(HWND hWnd){return(FALSE);}
int SetTrackerPos(DWORD dwValue){return(FALSE);}
int GetTrackerPos(){return(FALSE);}
int SetTrackerLength(DWORD dwValue){return(FALSE);}
int SetOpenFile(LPSTR szFile){return(FALSE);}
#endif

struct FindParam {
	LPSTR szText;
	DWORD dwFlags;
};

LONG APIENTRY FindDlgProc(HWND hWnd,UINT message,WPARAM wParam,LPARAM lParam)
{
	static struct FindParam * fp;
	switch(message) {
	case WM_COMMAND:
		switch(LOWORD(wParam)) {
		case IDOK:

			GetDlgItemText(hWnd,IDC_FINDTEXT,fp->szText,192);
			fp->dwFlags=0;
			if (IsDlgButtonChecked(hWnd,IDC_MATCHCASE)) fp->dwFlags|=FIND_MATCHCASE;
			if (IsDlgButtonChecked(hWnd,IDC_STARTTOP)) fp->dwFlags|=FIND_STARTTOP;
			if (!IsDlgButtonChecked(hWnd,IDC_SEARCHPATH)) fp->dwFlags|=FIND_SEARCHDISP;
			if (IsDlgButtonChecked(hWnd,IDC_INVERT)) fp->dwFlags|=FIND_INVERT;

			EndDialog(hWnd,TRUE);
			break;
		case IDCANCEL:
			EndDialog(hWnd,FALSE);
			break;
		}
		return TRUE;
		break;
	case WM_INITDIALOG:
		{
			fp=(struct FindParam *)lParam;
			if (fp->szText) {
				SetDlgItemText(hWnd,IDC_FINDTEXT,fp->szText);
			}
			if (fp->dwFlags&FIND_STARTTOP) CheckDlgButton(hWnd,IDC_STARTTOP,TRUE);
			if (fp->dwFlags&FIND_MATCHCASE) CheckDlgButton(hWnd,IDC_MATCHCASE,TRUE);
			if (fp->dwFlags&FIND_INVERT) CheckDlgButton(hWnd,IDC_INVERT,TRUE);
			if ((fp->dwFlags&FIND_SEARCHMASK)==FIND_SEARCHPATH)
				CheckDlgButton(hWnd,IDC_SEARCHPATH,TRUE);
		}
		return TRUE;
		break;
	default:
		return FALSE;
		break;
	}

}


int FindEntry(LPSTR szFindText,LPDWORD dwFlags)
{
	struct FindParam fp;
	fp.szText=szFindText;
	fp.dwFlags=*dwFlags;
	if (DialogBoxParam(GethInst(),"IDDFIND",GethWndMain(),(DLGPROC)FindDlgProc,(LPARAM)&fp)>0) {
		*dwFlags=fp.dwFlags;
		return TRUE;
	}
	return FALSE;
}


LPARAM APIENTRY PropertiesDlgProc(HWND hWnd,UINT message,WPARAM wParam,LPARAM lParam)
{
	switch(message) {
	case WM_COMMAND:
		switch(LOWORD(wParam)) {
		case IDOK:
		case 2:
			EndDialog(hWnd,TRUE);
			break;
		}
		return TRUE;
		break;
	case WM_INITDIALOG:
		{
			LPSTR szTrack      =NULL;
			LPSTR szTrackNo    =NULL;
			LPSTR szSource     =NULL;
			LPSTR szSourceType =NULL;
			LPSTR szArtist     =NULL;
			char lpString[MAX_PATH];
			LPSTR a;
			strcpy(lpString,(LPSTR)lParam);
			szTrack=strrchr(lpString,'\\');
			if (szTrack) {
				szTrack[0]='\0';
				szTrack++;
				if (szTrack[0]=='[') {
					if (szTrack[1]=='I'||szTrack[1]=='C') {
						szSourceType=&szTrack[1];
					} else {
						szTrackNo=&szTrack[1];
					}
					szTrack=strchr(szTrack,']');
					if (szTrack) {
						szTrack[0]='\0';
						szTrack++;
					}
				}
				a=strrchr(szTrack,'.');
				if (a) a[0]='\0';
				a=strrchr(lpString,'\\');
				if (a) {
					a[0]='\0';
					a++;
					if (a[0]=='[') {
						szSourceType=&a[1];
						szSource=strchr(a,']');
						if (szSource) {
							szSource[0]='\0';
							szSource++;
						}
						a=strrchr(lpString,'\\');
						if (a) {
							a++;
							szArtist=a;
						}
					} else {
						szArtist=a;
					}
				}

			}

			SetDlgItemText(hWnd,IDC_TRACKNAME,szTrack);
			SetDlgItemText(hWnd,IDC_ARTIST,szArtist);
			SetDlgItemText(hWnd,IDC_SOURCE,szSource);
			SetDlgItemText(hWnd,IDC_TRACK,szTrackNo);
			SetDlgItemText(hWnd,IDC_SOURCETYPE,szSourceType);
			return TRUE;
		}
		break;
	default:
		return FALSE;
		break;
	}

}
