/*
 * Script.cpp:
 *
 * This file is responsible for interpreting scripts.
 *
 * Copyright (c) Malcolm Smith 2001-2002.  No warranty is provided.
 */

#include "pch.h"

#ifdef SCRIPTING

#define MAX_PARAM 16

int scrAddHandler(LIST * List,LPSTR * szParam)
{
	LPSTR a;
	a=strrchr(szParam[0],'.');
	if (a) {
		a=a+1;
	} else {
		a=szParam[0];
	}
	AddHandler(a,szParam[1]);
	return(TRUE);
}


int scrClear(LIST * List,LPSTR * szParam)
{
	ClearList(List);
	return(TRUE);
}

int scrClearHandlers(LIST * List,LPSTR * szParam)
{
	ResetHandlers();
	return(TRUE);
}


int scrHide(LIST * List,LPSTR * szParam)
{
	DispWindow(GethWndMain(),FALSE);
	return(TRUE);
}


int scrImport(LIST * List,LPSTR * szParam)
{
	HANDLE hFind;
	pi_find fd;
	if ((hFind=pi_findfirst(szParam[0],&fd))!=INVALID_FIND_VALUE) {
		pi_findclose(hFind);
		if (getAttr(&fd)&FA_SUBDIR) {
			GenerateTree(List,szParam[0]);
		} else {
			InputFile(List,szParam[0]);
		}
	}
	return(TRUE);
}

int scrOntop(LIST * List,LPSTR * szParam)
{
	if (szParam[0]) {
		if (!strcmp(szParam[0],"false"))
			Setontop(GethWndMain(),FALSE);
	} else {
		Setontop(GethWndMain(),TRUE);
	}
	return(TRUE);
}


int scrPlay(LIST * List,LPSTR * szParam)
{
	unsigned long ul=0;
	if (szParam[0])
		sscanf(szParam[0],"%u",&ul);
	playMP3File(GethWndMain(),List,(int)ul);
	return(TRUE);
}

int scrShow(LIST * List,LPSTR * szParam)
{
	DispWindow(GethWndMain(),TRUE);
	return(TRUE);
}


int scrShuffle(LIST * List,LPSTR * szParam)
{
	ShuffleList(List);
	return(TRUE);
}

int scrSort(LIST * List,LPSTR * szParam)
{
	if (!strcmp(szParam[0],"path")) {
		SortList(List,SORT_PATH);
	} else {
		if (!strcmp(szParam[0],"file")) {
			SortList(List,SORT_FILE);
		} else {
			SortList(List,SORT_DISPLAY);
		}
	}
	return(TRUE);
}

int scrTracker(LIST * List,LPSTR * szParam)
{
	if (szParam[0]) {  
		if (!strcmp(szParam[0],"false"))
			SetTracker(GethWndMain(),FALSE);
	} else {
		SetTracker(GethWndMain(),TRUE);
	}
	return(TRUE);
}



int PlayScript(LIST * List,LPSTR szFile)
{
	FILE * fp;
	char szLine[1024];
	LPSTR szParam[MAX_PARAM];
	LPSTR a;
	int i;
	fp=fopen(szFile,"r");
	if (!fp) {
		return(FALSE);
	}

	fgets(szLine,sizeof(szLine),fp);
	a=strchr(szLine,'\r');
	if (a) a[0]='\0';
	a=strchr(szLine,'\n');
	if (a) a[0]='\0';


	while (!feof(fp)) {
		a=strchr(szLine,'#');
		if (a) a[0]='\0';
		if (strlen(szLine)) {
			for (i=0;i<MAX_PARAM;i++)
				szParam[i]=NULL;
			a=strchr(szLine,' ');
			if (a) {
				a[0]='\0';
				szParam[0]=a+1;
				i=0;
				while ((a=strchr(szParam[i],','))&&(i<MAX_PARAM)) {
					a[0]='\0';
					i++;
					szParam[i]=a+1;
				}

			}
			
			if (!strcmp(szLine,"AddHandler")) scrAddHandler(List,szParam);
			if (!strcmp(szLine,"Clear")) scrClear(List,szParam);
			if (!strcmp(szLine,"ClearHandlers")) scrClearHandlers(List,szParam);
			if (!strcmp(szLine,"Hide")) scrHide(List,szParam);
			if (!strcmp(szLine,"Import")) scrImport(List,szParam);
			if (!strcmp(szLine,"OnTop")) scrOntop(List,szParam);
			if (!strcmp(szLine,"Play")) scrPlay(List,szParam);
			if (!strcmp(szLine,"Show")) scrShow(List,szParam);
			if (!strcmp(szLine,"Shuffle")) scrShuffle(List,szParam);
			if (!strcmp(szLine,"Sort")) scrSort(List,szParam);
			if (!strcmp(szLine,"Tracker")) scrTracker(List,szParam);
		}
		fgets(szLine,sizeof(szLine),fp);
		a=strchr(szLine,'\r');
		if (a) a[0]='\0';
		a=strchr(szLine,'\n');
		if (a) a[0]='\0';

	}
	fclose(fp);
	return(TRUE);
}

#endif
